django_mldl/cv_project/cv_project/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    # 아래의 URL Pattern 을 opencv_webapp/urls.py가 handling
    path('', include('opencv_webapp.urls')),
]

django_mldl/cv_project/opencv_webapp/urls.py
from django.urls import path
from . import views
from django.conf import settings
from django.conf.urls.static import static

app_name = 'opencv_webapp'

urlpatterns = [
    path('', views.first_view, name='first_view'),
    path('simple_upload/', views.simple_upload, name='simple_upload'),
    path('detect_face/', views.detect_face, name='detect_face'),
]

urlpatterns += static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

django_mldl/cv_project/opencv_webapp/models.py
from django.db import models

# Create your models here.
class ImageUploadModel(models.Model):
    description = models.CharField(max_length=255, blank=True) # blank -> Optional
    # ses.jpg -> image/2020/02/17/ses.jpg
    document = models.ImageField(upload_to='image/%Y/%m/%d')
    # auto_now_add: 자동으로 저장되는 시점을 기준으로 현재 시간을 세팅
    uploaded_at = models.DateTimeField(auto_now_add=True)

django_mldl/cv_project/opencv_webapp/forms.py
from django import forms
from .models import ImageUploadModel
'''
1) Hard-coded HTML: form, input, label, button, ...
2) forms.Form: 양식(Form class) 안에 받아들일 Field 선언
3) forms.ModelForm: Model class 안에 받아들일 Field를 선언하고 해당 클래스를 당겨와 활용
'''
class SimpleUploadForm(forms.Form):
    title = forms.CharField(max_length=50)
    image = forms.ImageField()

class ImageUploadForm(forms.ModelForm):
    # Form을 통해 받아들어야 할 데이터가 명시되어 있는 메타 데이터 (DB 테이블을 연결)
    class Meta:
        model = ImageUploadModel
        # Form을 통해 사용자로부터 입력 받으려는 Model Class의 field 리스트
        fields = ('description', 'document',) # uploaded_at

django_mldl/cv_project/opencv_webapp/views.py
from django.shortcuts import render, redirect
from .forms import SimpleUploadForm, ImageUploadForm
from django.core.files.storage import FileSystemStorage
from django.conf import settings
from .cv_functions import cv_detect_face

# Create your views here.
def first_view(request):
    return render(request, 'opencv_webapp/first_view.html')

def simple_upload(request):
    if request.method == 'POST':
        form = SimpleUploadForm(request.POST, request.FILES)

        if form.is_valid():
            myfile = request.FILES['image']
            fs = FileSystemStorage()
            filename = fs.save(myfile.name, myfile)

            uploaded_file_url = fs.url(filename)

            context = {'form': form, 'uploaded_file_url': uploaded_file_url}
            return render(request, 'opencv_webapp/simple_upload.html', context)
    else:
        form = SimpleUploadForm()
        context = {'form': form}
        return render(request, 'opencv_webapp/simple_upload.html', context)

def detect_face(request):
    if request.method == 'POST':
        form = ImageUploadForm(request.POST, request.FILES)
        if form.is_valid():
            post = form.save(commit=False)
            post.save()

            imageURL = settings.MEDIA_URL + form.instance.document.name
            cv_detect_face(settings.MEDIA_ROOT_URL + imageURL)

            return render(request, 'opencv_webapp/detect_face.html', {'form': form, 'post': post})

    else:
        form = ImageUploadForm()
        return render(request, 'opencv_webapp/detect_face.html', {'form': form})

django_mldl/cv_project/opencv_webapp/templates/opencv_webapp/detect_face.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <title>Opencv-Django</title>
  </head>
  <body>

    <form method="POST" enctype="multipart/form-data">
      {% csrf_token %}
      {{ form.as_p }}
      <button type="submit">Upload</button>
    </form>

    {% if post %}
      <!-- post.document : ImageUploadModel Class에 선언되어 있는 "document"에 해당 -->
      <img src="{{ post.document.url }}">
      <p>Uploaded file @ : <a href="{{ post.document.url }}">{{ post.document }}</a></p>
    {% endif %}

    <p><a href="{% url 'opencv_webapp:detect_face' %}">Return to home</a></p>

  </body>
</html>

django_mldl/cv_project/opencv_webapp/templates/opencv_webapp/first_view.html
<!DOCTYPE html>
<html lang="en">

  <head>
    <meta charset="utf-8">
    <title>Opencv-Django</title>
  </head>

  <body>
    Hello world!
  </body>

</html>

django_mldl/cv_project/opencv_webapp/templates/opencv_webapp/simple_upload.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>Opencv-Django</title>
  </head>
  <body>
    <h1>Upload your image file.</h1>

    <form method="POST" enctype="multipart/form-data">
      {% csrf_token %}
      {{ form.as_p }}
      <button type="submit">Upload</button>
    </form>

    {% if uploaded_file_url %}
      <img src="{{ uploaded_file_url }}">
      <p>Uploaded file @: <a href="{{ uploaded_file_url }}">{{ uploaded_file_url }}</a></p>
    {% endif %}

    <p><a href="{% url 'opencv_webapp:simple_upload' %}">Return to home</a></p>
  </body>
</html>